SystemOrganization addCategory: #'Pier-FileUpload-Wysiwyg'!

PRFileUploadWysiwygEditorBase subclass: #PRFileUploadWysiwygEditor
	instanceVariableNames: 'uploadComponent notificationId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-FileUpload-Wysiwyg'!

!PRFileUploadWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/17/2011 19:44'!
defineElementIdsOn: html
	self notificationId: html nextId.
	self editor textId: html nextId
	! !

!PRFileUploadWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/17/2011 19:58'!
defineUploadConfiguration
	self uploadComponent configuration
		onFileUploaded: [ :file | self storeUploadedFile: file ];
		onBeforeUpload: ('$("#', self notificationId, '").html("<div>uploading...</div>")') asFunction;
		onUploadResponse: ((JSStream on: ('$("#', self notificationId, '").html(renderedResponse);
			if (uploadedFile){$("#', self editor textId, '_insertimage_url").val(uploadedFile.url)}')) asFunction: #('renderedResponse' 'uploadedFile')) ! !

!PRFileUploadWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 8/17/2011 19:26'!
notificationId
	^ notificationId! !

!PRFileUploadWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 8/17/2011 19:26'!
notificationId: anObject
	notificationId := anObject! !

!PRFileUploadWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 8/17/2011 19:26'!
onUploadErrorCallback
	^ '$("#', self notificationId, '").html ("<div class=''status''>" + statusText + "</div>")' asFunction: #(statusText)! !

!PRFileUploadWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 8/17/2011 19:26'!
onUploadProgressCallback
 ^ 
'var clearUploadProgress = function() {
	$("#', self progressBarId, '").hide();
	setUploadStatus ("");
}

var setUploadStatus = function (statusText) {
	$("#', self notificationId, '").html ("<div class=''status''>" + statusText + "</div>");
}

if (uploadStatus.state == "uploading") {
	var percentageComplete = Math.floor(uploadStatus.received * 100 / uploadStatus.size);
	$("#', self progressBarId, '").progressbar({ value: percentageComplete });
	if (uploadStatus.received !!= uploadStatus.size) {
		setUploadStatus("Uploading: " + percentageComplete + "%");
	} else {
		setUploadStatus("Uploaded: processing");
	}
}
if (uploadStatus.state == "starting") {
	setUploadStatus("Starting upload");
}
if (uploadStatus.state == "done") {
	$("#', self progressBarId, '").progressbar({ value: 100 });
	clearUploadProgress();
}' asFunction: #(uploadStatus) ! !

!PRFileUploadWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/17/2011 19:26'!
renderEditorOn: html
	self defineElementIdsOn: html.
	self defineUploadConfiguration.
	
	self renderEditorInsertImagePopupOn: html.
	super renderEditorOn: html! !

!PRFileUploadWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/19/2011 08:29'!
renderUploaderOn: html
	html div: [
		html render: self uploadComponent.
		html div id: self notificationId ].! !

!PRFileUploadWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 12/5/2011 11:28'!
storeUploadedFile: file
    | stream destinationFilepath destinationDirectory storedFile filename fileStructure |

	filename := self createValidName: file fileName.
	destinationFilepath := self createUploadedFilepath: filename.
	
	destinationDirectory := (FileDirectory forFileName: destinationFilepath).
    	stream := destinationDirectory forceNewFileNamed: filename.
	[  stream 
		binary; 
		nextPutAll: 
		file rawContents ] 
	ensure: [ stream close ].
	
	storedFile := (NAExternalFile filesize: file size filename: filename filepath: destinationFilepath  mimetype: file contentType).
	fileStructure := self createUploadedStructure: storedFile.
	storedFile url: fileStructure url.
	
	^ storedFile! !

!PRFileUploadWysiwygEditor methodsFor: 'components' stamp: 'NickAger 8/19/2011 09:38'!
uploadComponent
	^ uploadComponent ifNil: [ uploadComponent := NAFileUpload new ]! !

!PRCase class methodsFor: '*pier-fileupload-wysiwyg' stamp: 'NickAger 11/25/2011 14:28'!
descriptionDocumentWysiwyg2: aDescription
       ^ aDescription componentClass: PRFileUploadWysiwygEditor! !
